-- Ajout colonnes

ALTER TABLE Segment
	ADD (nbSalle TINYINT(2) DEFAULT 0, nbPoste TINYINT(2) DEFAULT 0);

ALTER TABLE Logiciel 
	ADD nbInstall TINYINT(2) DEFAULT 0;

--pose des fois pb, faire exit et relancer...
ALTER TABLE Poste ADD nbLog TINYINT(2) DEFAULT 0;

DESC Segment;
DESC Logiciel;
DESC Poste;

SELECT * FROM Segment;
SELECT * FROM Logiciel;
SELECT * FROM Poste;

-- Modif colonnes
ALTER TABLE Salle MODIFY nomSalle VARCHAR(30);

DESC Salle;

SELECT * FROM Salle;

-- tentative :
-- +long 'Brin 2me tage' : 15 caractres

ALTER TABLE Segment MODIFY nomSegment VARCHAR(15);

-- tentative
ALTER TABLE Segment MODIFY nomSegment VARCHAR(14);

DESC Segment;

SELECT * FROM Segment;

--Ajout de contraintes

-- Ajouter la contrainte afin de sassurer quon ne puisse installer 
-- plusieurs fois le mme logiciel sur un poste de travail donn.

ALTER TABLE Installer ADD CONSTRAINT un_installation UNIQUE(nPoste,nLog);

--pose pb des fois!

ALTER TABLE Poste 
  ADD CONSTRAINT fk_Poste_indIP_Segment  
  FOREIGN KEY(indIP)
  REFERENCES Segment(indIP);

ALTER TABLE Poste 
  ADD CONSTRAINT fk_Poste_nSalle_Salle
  FOREIGN KEY(nSalle)
  REFERENCES Salle(nSalle);

ALTER TABLE Poste 
  ADD CONSTRAINT fk_Poste_typePoste_Types 
  FOREIGN KEY(typePoste)
  REFERENCES Types(typeLP);

ALTER TABLE Installer
  ADD CONSTRAINT fk_Installer_nPoste_Poste
  FOREIGN KEY(nPoste)
  REFERENCES Poste(nPoste);

ALTER TABLE Installer
  ADD CONSTRAINT fk_Installer_nLog_Logiciel
  FOREIGN KEY(nLog)
  REFERENCES Logiciel(nLog);

--Erreurs

-- commande refuses 

ALTER TABLE Logiciel
  ADD CONSTRAINT fk_Logiciel_typeLog_Types 
  FOREIGN KEY(typeLog)
  REFERENCES Types(typeLP);

ALTER TABLE Salle
  ADD CONSTRAINT fk_Salle_indIP_Segment  
  FOREIGN KEY(indIP)
  REFERENCES Segment(indIP);

--erreurs :

SELECT nLog FROM Logiciel WHERE typeLog NOT IN (SELECT typeLP FROM Types);

SELECT nSalle FROM Salle WHERE indIP NOT IN (SELECT indIP FROM Segment);


--rsolution des rejets


--Supprimer les enregistrements de la table Salle qui posent problme. 

DELETE FROM Salle WHERE indIP NOT IN (SELECT indIP FROM Segment);

--Ajouter le type de logiciel (BeOS, Systme Be)

INSERT INTO Types VALUES ('BeOS','Systme Be');


-- commandes OK

ALTER TABLE Logiciel
  ADD CONSTRAINT fk_Logiciel_typeLog_Types 
  FOREIGN KEY(typeLog)
  REFERENCES Types(typeLP);

ALTER TABLE Salle
  ADD CONSTRAINT fk_Salle_indIP_Segment  
  FOREIGN KEY(indIP)
  REFERENCES Segment(indIP);



